Index: dll/ntdll/CMakeLists.txt
===================================================================
--- dll/ntdll/CMakeLists.txt	(revision 60442)
+++ dll/ntdll/CMakeLists.txt	(working copy)
@@ -52,6 +52,7 @@
                       rtl
                       ntdllsys
                       libcntpr
+                      uuid
                       ${PSEH_LIB})
 
 add_pch(ntdll include/ntdll.h)
Index: dll/ntdll/def/ntdll.spec
===================================================================
--- dll/ntdll/def/ntdll.spec	(revision 60442)
+++ dll/ntdll/def/ntdll.spec	(working copy)
@@ -405,7 +405,7 @@
 @ stdcall -arch=x86_64 RtlAddFunctionTable(ptr long long)
 ;@ stdcall RtlAddMandatoryAce(ptr long long long long ptr)
 @ stdcall RtlAddRefActivationContext(ptr)
-;@ stdcall RtlAddRefMemoryStream
+@ stdcall RtlAddRefMemoryStream(ptr)
 @ stdcall RtlAddVectoredContinueHandler(long ptr)
 @ stdcall RtlAddVectoredExceptionHandler(long ptr)
 ;@ stdcall RtlAddressInSectionTable
@@ -440,8 +440,8 @@
 @ stdcall RtlCheckRegistryKey(long ptr)
 @ stdcall RtlClearAllBits(ptr)
 @ stdcall RtlClearBits(ptr long long)
-;@ stdcall RtlCloneMemoryStream
-;@ stdcall RtlCommitMemoryStream
+@ stdcall RtlCloneMemoryStream(ptr ptr)
+@ stdcall RtlCommitMemoryStream(ptr long)
 @ stdcall RtlCompactHeap(long long)
 @ stdcall RtlCompareMemory(ptr ptr long)
 @ stdcall RtlCompareMemoryUlong(ptr long long)
@@ -464,8 +464,8 @@
 @ stdcall RtlCopyLuid(ptr ptr)
 @ stdcall RtlCopyLuidAndAttributesArray(long ptr ptr)
 ;@ stdcall RtlCopyMappedMemory
-;@ stdcall RtlCopyMemoryStreamTo
-;@ stdcall RtlCopyOutOfProcessMemoryStreamTo
+@ stdcall RtlCopyMemoryStreamTo(ptr ptr int64 ptr ptr)
+@ stdcall RtlCopyOutOfProcessMemoryStreamTo(ptr ptr int64 ptr ptr)
 ;@ stdcall RtlCopyRangeList ; 5.0 and 5.1 only
 @ stdcall RtlCopySecurityDescriptor(ptr ptr)
 @ stdcall RtlCopySid(long ptr ptr)
@@ -571,7 +571,7 @@
 @ stdcall -arch=win32 -ret64 RtlExtendedMagicDivide(double double long)
 @ stdcall RtlFillMemory(ptr long long)
 @ stdcall RtlFillMemoryUlong(ptr long long)
-;@ stdcall RtlFinalReleaseOutOfProcessMemoryStream
+@ stdcall RtlFinalReleaseOutOfProcessMemoryStream(ptr)
 @ stdcall RtlFindActivationContextSectionGuid(long ptr long ptr ptr)
 @ stdcall RtlFindActivationContextSectionString(long ptr long ptr ptr)
 @ stdcall RtlFindCharInUnicodeString(long ptr ptr ptr)
@@ -658,9 +658,9 @@
 @ stdcall RtlInitAnsiString(ptr str)
 @ stdcall RtlInitAnsiStringEx(ptr str)
 @ stdcall RtlInitCodePageTable(ptr ptr)
-;@ stdcall RtlInitMemoryStream
+@ stdcall RtlInitMemoryStream(ptr)
 @ stdcall RtlInitNlsTables(ptr ptr ptr ptr)
-;@ stdcall RtlInitOutOfProcessMemoryStream
+@ stdcall RtlInitOutOfProcessMemoryStream(ptr)
 @ stdcall RtlInitString(ptr str)
 @ stdcall RtlInitUnicodeString(ptr wstr)
 @ stdcall RtlInitUnicodeStringEx(ptr wstr)
@@ -735,7 +735,7 @@
 @ stdcall RtlLocalTimeToSystemTime(ptr ptr)
 @ stdcall RtlLockBootStatusData(ptr)
 @ stdcall RtlLockHeap(long)
-;@ stdcall RtlLockMemoryStreamRegion
+@ stdcall RtlLockMemoryStreamRegion(ptr int64 int64 long)
 ;@ stdcall RtlLogStackBackTrace
 @ stdcall RtlLookupAtomInAtomTable(ptr wstr ptr)
 @ stdcall RtlLookupElementGenericTable(ptr ptr)
@@ -781,7 +781,7 @@
 @ stdcall RtlQueryInformationAcl(ptr ptr long long)
 @ stdcall RtlQueryInformationActivationContext(long long ptr long ptr long ptr)
 @ stdcall RtlQueryInformationActiveActivationContext(long ptr long ptr)
-;@ stdcall RtlQueryInterfaceMemoryStream
+@ stdcall RtlQueryInterfaceMemoryStream(ptr ptr ptr)
 ;@ stdcall RtlQueryProcessBackTraceInformation
 @ stdcall RtlQueryProcessDebugInformation(long long ptr)
 ;@ stdcall RtlQueryProcessHeapInformation
@@ -800,14 +800,14 @@
 @ stdcall RtlRandom(ptr)
 @ stdcall RtlRandomEx(ptr)
 @ stdcall RtlReAllocateHeap(long long ptr long)
-;@ stdcall RtlReadMemoryStream
-;@ stdcall RtlReadOutOfProcessMemoryStream
+@ stdcall RtlReadMemoryStream(ptr ptr long ptr)
+@ stdcall RtlReadOutOfProcessMemoryStream(ptr ptr long ptr)
 @ stdcall RtlRealPredecessor(ptr)
 @ stdcall RtlRealSuccessor(ptr)
 @ stdcall RtlRegisterSecureMemoryCacheCallback(ptr)
 @ stdcall RtlRegisterWait(ptr ptr ptr ptr long long)
 @ stdcall RtlReleaseActivationContext(ptr)
-;@ stdcall RtlReleaseMemoryStream
+@ stdcall RtlReleaseMemoryStream(ptr)
 @ stdcall RtlReleasePebLock()
 @ stdcall RtlReleasePrivilege(ptr)
 @ stdcall RtlReleaseRelativeName(ptr)
@@ -820,12 +820,12 @@
 @ stdcall RtlResetRtlTranslations(ptr)
 @ stdcall -arch=x86_64 RtlRestoreContext(ptr ptr)
 @ stdcall RtlRestoreLastWin32Error(long) RtlSetLastWin32Error
-;@ stdcall RtlRevertMemoryStream
+@ stdcall RtlRevertMemoryStream(ptr)
 @ stdcall RtlRunDecodeUnicodeString(long ptr)
 @ stdcall RtlRunEncodeUnicodeString(long ptr)
 @ stdcall RtlSecondsSince1970ToTime(long ptr)
 @ stdcall RtlSecondsSince1980ToTime(long ptr)
-;@ stdcall RtlSeekMemoryStream
+@ stdcall RtlSeekMemoryStream(ptr int64 long ptr)
 @ stdcall RtlSelfRelativeToAbsoluteSD2(ptr ptr)
 @ stdcall RtlSelfRelativeToAbsoluteSD(ptr ptr ptr ptr ptr ptr ptr ptr ptr ptr ptr)
 @ stdcall RtlSetAllBits(ptr)
@@ -844,7 +844,7 @@
 @ stdcall RtlSetIoCompletionCallback(long ptr long)
 @ stdcall RtlSetLastWin32Error(long)
 @ stdcall RtlSetLastWin32ErrorAndNtStatusFromNtStatus(long)
-;@ stdcall RtlSetMemoryStreamSize
+@ stdcall RtlSetMemoryStreamSize(ptr int64)
 @ stdcall RtlSetOwnerSecurityDescriptor(ptr ptr long)
 @ stdcall RtlSetProcessIsCritical(long ptr long)
 ;@ stdcall RtlSetProperties ; RtlSetProperties
@@ -869,7 +869,7 @@
 @ stdcall RtlSleepConditionVariableSRW(ptr ptr ptr long)
 @ stdcall RtlSplay(ptr)
 ;@ stdcall RtlStartRXact
-;@ stdcall RtlStatMemoryStream
+@ stdcall RtlStatMemoryStream(ptr ptr long)
 @ stdcall RtlStringFromGUID(ptr ptr)
 @ stdcall RtlSubAuthorityCountSid(ptr)
 @ stdcall RtlSubAuthoritySid(ptr long)
@@ -907,7 +907,7 @@
 @ stdcall RtlUniform(ptr)
 @ stdcall RtlUnlockBootStatusData(ptr)
 @ stdcall RtlUnlockHeap(long)
-;@ stdcall RtlUnlockMemoryStreamRegion
+@ stdcall RtlUnlockMemoryStreamRegion(ptr int64 int64 long)
 @ stdcall -register RtlUnwind(ptr ptr ptr ptr)
 @ stdcall -arch=x86_64 RtlUnwindEx(long long ptr long ptr)
 @ stdcall RtlUpcaseUnicodeChar(long)
@@ -938,7 +938,7 @@
 @ stdcall RtlWow64EnableFsRedirectionEx(long ptr)
 @ stdcall RtlWakeAllConditionVariable(ptr)
 @ stdcall RtlWakeConditionVariable(ptr)
-;@ stdcall RtlWriteMemoryStream
+@ stdcall RtlWriteMemoryStream(ptr ptr long ptr)
 @ stdcall RtlWriteRegistryValue(long ptr ptr long ptr long)
 @ stdcall RtlZeroHeap(ptr long)
 @ stdcall RtlZeroMemory(ptr long)
Index: include/ndk/rtlfuncs.h
===================================================================
--- include/ndk/rtlfuncs.h	(revision 60442)
+++ include/ndk/rtlfuncs.h	(working copy)
@@ -4152,6 +4152,168 @@
 );
 #endif
 
+//
+// MemoryStream functions
+//
+#ifdef NTOS_MODE_USER
+
+// external declarations
+struct IStreamVtbl;
+typedef struct IStream IStream;
+typedef struct tagSTATSTG STATSTG, *PSTATSTG;
+
+typedef struct IMemoryStream
+{
+    struct IStreamVtbl *lpVtbl;
+    DWORD RefCount;
+    DWORD Unk1;
+    PBYTE Current;
+    PBYTE Start;
+    PBYTE End;
+    DWORD Unk2;
+    DWORD Unk3;
+} RTL_MEMORY_STREAM, *PRTL_MEMORY_STREAM;
+
+NTSYSAPI
+VOID
+NTAPI
+RtlInitMemoryStream(PRTL_MEMORY_STREAM stream);
+
+NTSYSAPI
+VOID
+NTAPI
+RtlInitOutOfProcessMemoryStream(PRTL_MEMORY_STREAM stream);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlQueryInterfaceMemoryStream( 
+    _In_ IStream * This,
+    _In_ REFIID riid,
+    _Outptr_result_maybenull_ PVOID *ppvObject);
+
+NTSYSAPI
+ULONG
+NTAPI
+RtlAddRefMemoryStream( 
+    _In_ IStream * This);
+
+NTSYSAPI
+ULONG
+NTAPI
+RtlReleaseMemoryStream( 
+    _In_ IStream * This);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlReadMemoryStream( 
+    _In_ IStream * This,
+    _Out_writes_bytes_(cb) PVOID pv,
+    _In_ ULONG cb,
+    _Out_opt_ PULONG pcbRead);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlReadOutOfProcessMemoryStream( 
+    _In_ IStream * This,
+    _Out_writes_bytes_(cb) PVOID pv,
+    _In_ ULONG cb,
+    _Out_opt_ PULONG pcbRead);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlWriteMemoryStream( 
+    _In_ IStream * This,
+    _In_reads_bytes_(cb) const void * pv,
+    _In_ ULONG cb,
+    _Out_opt_ PULONG pcbWritten);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlSeekMemoryStream( 
+    _In_ IStream * This,
+    _In_ LARGE_INTEGER dlibMove,
+    _In_ DWORD dwOrigin,
+    _Out_opt_ PULARGE_INTEGER plibNewPosition);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlSetMemoryStreamSize( 
+    _In_ IStream * This,
+    _In_ ULARGE_INTEGER libNewSize);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlCopyMemoryStreamTo( 
+    _In_ IStream * This,
+    _In_ IStream * pstm,
+    _In_ ULARGE_INTEGER cb,
+    _Out_opt_ PULARGE_INTEGER pcbRead,
+    _Out_opt_ PULARGE_INTEGER pcbWritten);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlCopyOutOfProcessMemoryStreamTo( 
+    _In_ IStream * This,
+    _In_ IStream * pstm,
+    _In_ ULARGE_INTEGER cb,
+    _Out_opt_ PULARGE_INTEGER pcbRead,
+    _Out_opt_ PULARGE_INTEGER pcbWritten);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlCommitMemoryStream( 
+    _In_ IStream * This,
+    _In_ DWORD grfCommitFlags);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlRevertMemoryStream( 
+    _In_ IStream * This);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlLockMemoryStreamRegion( 
+    _In_ IStream * This,
+    _In_ ULARGE_INTEGER libOffset,
+    _In_ ULARGE_INTEGER cb,
+    _In_ DWORD dwLockType);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlUnlockMemoryStreamRegion( 
+    _In_ IStream * This,
+    _In_ ULARGE_INTEGER libOffset,
+    _In_ ULARGE_INTEGER cb,
+    _In_ DWORD dwLockType);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlStatMemoryStream( 
+    _In_ IStream * This,
+    _Out_ PSTATSTG pstatstg,
+    _In_ DWORD grfStatFlag);
+
+NTSYSAPI
+NTSTATUS
+NTAPI
+RtlCloneMemoryStream( 
+    _In_ IStream * This,
+    _Outptr_result_maybenull_ IStream **ppvStream);
+#endif
+
 #ifdef __cplusplus
 }
 #endif
Index: lib/rtl/CMakeLists.txt
===================================================================
--- lib/rtl/CMakeLists.txt	(revision 60442)
+++ lib/rtl/CMakeLists.txt	(working copy)
@@ -33,6 +33,7 @@
     heapuser.c
     image.c
     interlck.c
+    memstream.c
     message.c
     largeint.c
     luid.c
Index: lib/rtl/memstream.c
===================================================================
--- lib/rtl/memstream.c	(revision 0)
+++ lib/rtl/memstream.c	(working copy)
@@ -0,0 +1,355 @@
+/* COPYRIGHT:       See COPYING in the top level directory
+ * PROJECT:         ReactOS system libraries
+ * FILE:            lib/rtl/mem.c
+ * PURPOSE:         MemoryStream functions
+ * PROGRAMMER:      David Quintana (gigaherz@gmail.com)
+ */
+
+/* INCLUDES *****************************************************************/
+
+#include <rtl.h>
+
+#define NDEBUG
+#include <debug.h>
+
+/* Virtual Method Tables******************************************************/
+
+struct IStreamVtbl RtlMemoryStreamVtbl = {
+    RtlQueryInterfaceMemoryStream,
+    RtlAddRefMemoryStream,
+    RtlReleaseMemoryStream,
+    RtlReadMemoryStream,
+    RtlWriteMemoryStream,
+    RtlSeekMemoryStream,
+    RtlSetMemoryStreamSize,
+    RtlCopyMemoryStreamTo,
+    RtlCommitMemoryStream,
+    RtlRevertMemoryStream,
+    RtlLockMemoryStreamRegion,
+    RtlUnlockMemoryStreamRegion,
+    RtlStatMemoryStream,
+    RtlCloneMemoryStream,
+};
+
+struct IStreamVtbl RtlOutOfProcessMemoryStreamVtbl = {
+    RtlQueryInterfaceMemoryStream,
+    RtlAddRefMemoryStream,
+    RtlReleaseMemoryStream,
+    RtlReadOutOfProcessMemoryStream,
+    RtlWriteMemoryStream,
+    RtlSeekMemoryStream,
+    RtlSetMemoryStreamSize,
+    RtlCopyOutOfProcessMemoryStreamTo,
+    RtlCommitMemoryStream,
+    RtlRevertMemoryStream,
+    RtlLockMemoryStreamRegion,
+    RtlUnlockMemoryStreamRegion,
+    RtlStatMemoryStream,
+    RtlCloneMemoryStream,
+};
+
+/* FUNCTIONS *****************************************************************/
+
+/*
+ * @implemented
+ */
+VOID
+NTAPI
+RtlInitMemoryStream(PRTL_MEMORY_STREAM stream)
+{
+    stream->lpVtbl = &RtlMemoryStreamVtbl;
+}
+
+/*
+ * @unimplemented
+ */
+VOID
+NTAPI
+RtlInitOutOfProcessMemoryStream(PRTL_MEMORY_STREAM stream)
+{
+    stream->lpVtbl = &RtlOutOfProcessMemoryStreamVtbl;
+    UNIMPLEMENTED;
+}
+
+/*
+ * @unimplemented
+ */
+VOID
+NTAPI
+RtlFinalReleaseOutOfProcessMemoryStream(PRTL_MEMORY_STREAM stream)
+{
+    UNIMPLEMENTED;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlQueryInterfaceMemoryStream( 
+    _In_ IStream * This,
+    _In_ REFIID riid,
+    _Outptr_result_maybenull_ PVOID *ppvObject)
+{
+    if (IsEqualGUID(&IID_IUnknown, riid) 
+     || IsEqualGUID(&IID_ISequentialStream, riid)
+     || IsEqualGUID(&IID_IStream, riid)) {
+        *ppvObject = This;
+        return S_OK;
+    }
+
+    *ppvObject = NULL;
+    return E_NOINTERFACE;
+}
+
+/*
+ * @implemented
+ */
+ULONG
+NTAPI
+RtlAddRefMemoryStream( 
+    _In_ IStream * This)
+{
+    PRTL_MEMORY_STREAM pstream = (PRTL_MEMORY_STREAM)This;
+    
+    pstream->RefCount++;
+    
+    return 2;
+}
+
+ULONG
+NTAPI
+RtlReleaseMemoryStream( 
+    _In_ IStream * This)
+{
+    PRTL_MEMORY_STREAM pstream = (PRTL_MEMORY_STREAM)This;
+    
+    pstream->RefCount--;
+    
+    if(pstream->RefCount == 0)
+        DPRINT1("TODO: RefCount reached 0\n");
+    
+    return 1;
+}
+
+/*
+ * @unimplemented
+ */
+NTSTATUS
+NTAPI
+RtlReadMemoryStream( 
+    _In_ IStream * This,
+    _Out_writes_bytes_(cb) PVOID pv,
+    _In_ ULONG cb,
+    _Out_opt_ PULONG pcbRead)
+{
+    if(pcbRead) *pcbRead = 0;
+        
+    if (!cb) return S_OK;
+    
+    
+    
+    return E_NOTIMPL;
+}
+
+/*
+ * @unimplemented
+ */
+NTSTATUS
+NTAPI
+RtlReadOutOfProcessMemoryStream( 
+    _In_ IStream * This,
+    _Out_writes_bytes_(cb) PVOID pv,
+    _In_ ULONG cb,
+    _Out_opt_ PULONG pcbRead)
+{
+    UNIMPLEMENTED;
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlSeekMemoryStream( 
+    _In_ IStream * This,
+    _In_ LARGE_INTEGER dlibMove,
+    _In_ DWORD dwOrigin,
+    _Out_opt_ PULARGE_INTEGER plibNewPosition)
+{
+    PRTL_MEMORY_STREAM pstream = (PRTL_MEMORY_STREAM)This;
+    
+    switch(dwOrigin)
+    {
+        case STREAM_SEEK_SET:
+            pstream->Current = pstream->Start + (SIZE_T)dlibMove.QuadPart;
+            break;
+            
+        case STREAM_SEEK_CUR:
+            pstream->Current = pstream->Current + (SIZE_T)dlibMove.QuadPart;
+            break;
+        
+        case STREAM_SEEK_END:
+            pstream->Current = pstream->End + (SIZE_T)dlibMove.QuadPart;
+            break;
+            
+        default:
+            return E_INVALIDARG;
+    }
+    
+    if(plibNewPosition)
+    {
+        plibNewPosition->QuadPart = pstream->Current - pstream->Start;
+    }
+    
+    return S_OK;
+}
+
+/*
+ * @unimplemented
+ */
+NTSTATUS
+NTAPI
+RtlCopyMemoryStreamTo( 
+    _In_ IStream * This,
+    _In_ IStream * pstm,
+    _In_ ULARGE_INTEGER cb,
+    _Out_opt_ PULARGE_INTEGER pcbRead,
+    _Out_opt_ PULARGE_INTEGER pcbWritten)
+{
+    UNIMPLEMENTED;
+    return E_NOTIMPL;
+}
+
+/*
+ * @unimplemented
+ */
+NTSTATUS
+NTAPI
+RtlCopyOutOfProcessMemoryStreamTo( 
+    _In_ IStream * This,
+    _In_ IStream * pstm,
+    _In_ ULARGE_INTEGER cb,
+    _Out_opt_ PULARGE_INTEGER pcbRead,
+    _Out_opt_ PULARGE_INTEGER pcbWritten)
+{
+    UNIMPLEMENTED;
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlStatMemoryStream( 
+    _In_ IStream * This,
+    _Out_ PSTATSTG pstatstg,
+    _In_ DWORD grfStatFlag)
+{
+    PRTL_MEMORY_STREAM pstream = (PRTL_MEMORY_STREAM)This;
+    
+    if (!pstatstg) return E_INVALIDARG;
+
+    ZeroMemory(pstatstg, sizeof(STATSTG));
+    pstatstg->type = STGTY_STREAM;
+    pstatstg->cbSize.QuadPart = pstream->End - pstream->Start;
+
+    return S_OK;
+}
+
+// Dummy functions
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlWriteMemoryStream( 
+    _In_ IStream * This,
+    _In_reads_bytes_(cb) const void * pv,
+    _In_ ULONG cb,
+    _Out_opt_ PULONG pcbWritten)
+{
+    // Dummy
+    return E_NOTIMPL;
+}
+
+NTSTATUS
+NTAPI
+RtlSetMemoryStreamSize( 
+    _In_ IStream * This,
+    _In_ ULARGE_INTEGER libNewSize)
+{
+    // Dummy
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlCommitMemoryStream( 
+    _In_ IStream * This,
+    _In_ DWORD grfCommitFlags)
+{
+    // Dummy
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlRevertMemoryStream( 
+    _In_ IStream * This)
+{
+    // Dummy
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlLockMemoryStreamRegion( 
+    _In_ IStream * This,
+    _In_ ULARGE_INTEGER libOffset,
+    _In_ ULARGE_INTEGER cb,
+    _In_ DWORD dwLockType)
+{
+    // Dummy
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlUnlockMemoryStreamRegion( 
+    _In_ IStream * This,
+    _In_ ULARGE_INTEGER libOffset,
+    _In_ ULARGE_INTEGER cb,
+    _In_ DWORD dwLockType)
+{
+    // Dummy
+    return E_NOTIMPL;
+}
+
+/*
+ * @implemented
+ */
+NTSTATUS
+NTAPI
+RtlCloneMemoryStream( 
+    _In_ IStream * This,
+    _Outptr_result_maybenull_ IStream **ppvStream)
+{
+    // Dummy
+    return E_NOTIMPL;
+}