Index: reactos/dll/cpl/appwiz/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/appwiz/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/appwiz/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+﻿LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
 IDD_FIRSTPAGE DIALOGEX 0, 0, PROPSHEETWIDTH, PROPSHEETHEIGHT
 STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
@@ -51,19 +51,19 @@
 
 STRINGTABLE
 BEGIN
-    IDS_DOWNLOADING     "Downloading..."
-    IDS_INSTALLING      "Installing..."
-    IDS_INVALID_SHA     "Unexpected checksum of downloaded file. Aborting installation of corrupted file."
+    IDS_DOWNLOADING     "Загрузка..."
+    IDS_INSTALLING      "Установка..."
+    IDS_INVALID_SHA     "Ошибка контрольной суммы загруженного файла. Прерывание установки поврежденного файла."
 END
 
 ID_DWL_GECKO_DIALOG DIALOG  0, 0, 260, 95
 STYLE DS_MODALFRAME | DS_CENTER | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "Wine Gecko Installer"
+CAPTION "Установщик Wine Gecko"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    CONTROL "ReactOS could not find a Wine Gecko package which is needed for applications embedding HTML to work correctly. ReactOS can automatically download and install it for you.",
+    CONTROL "ReactOS не может найти Wine Gecko пакет, который необходим для приложений с поддержкой HTML, чтобы работать правильно. ReactOS может автоматически загрузить и устанавить ее для вас.",
           ID_DWL_STATUS, "SysLink", 0, 10, 10, 240, 65
     CONTROL "", ID_DWL_PROGRESS, PROGRESS_CLASSA, WS_BORDER | PBS_SMOOTH, 10, 40, 240, 12
-    DEFPUSHBUTTON "&Install", ID_DWL_INSTALL, 200, 76, 50, 14, WS_GROUP | WS_TABSTOP
-    PUSHBUTTON "Cancel", IDCANCEL, 144, 76, 50, 14, WS_GROUP | WS_TABSTOP
+    DEFPUSHBUTTON "&Установить", ID_DWL_INSTALL, 200, 76, 50, 14, WS_GROUP | WS_TABSTOP
+    PUSHBUTTON "Отмена", IDCANCEL, 144, 76, 50, 14, WS_GROUP | WS_TABSTOP
 END
Index: reactos/dll/cpl/inetcpl/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/inetcpl/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/inetcpl/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-/*
+﻿/*
  * Russian resources for the Internet control panel applet
  *
  * Copyright 2011 Alexander Lakhin
@@ -104,13 +104,13 @@
 
 STRINGTABLE
 BEGIN
-    IDS_CPL_NAME        "Internet Settings"
-    IDS_CPL_INFO        "Configure Wine Internet Browser and related settings"
-    IDS_SEC_SETTINGS    "Security settings for zone: "
-    IDS_SEC_LEVEL0      "Custom"
-    IDS_SEC_LEVEL1      "Very Low"
-    IDS_SEC_LEVEL2      "Low"
-    IDS_SEC_LEVEL3      "Medium"
-    IDS_SEC_LEVEL4      "Increased"
-    IDS_SEC_LEVEL5      "High"
+    IDS_CPL_NAME        "Интернет-Настройки"
+    IDS_CPL_INFO        "Настроить Wine Интернет-Браузер и настройки, связанные с"
+    IDS_SEC_SETTINGS    "Параметры безопасности этой зоны: "
+    IDS_SEC_LEVEL0      "Пользовательские"
+    IDS_SEC_LEVEL1      "Очень Низкая"
+    IDS_SEC_LEVEL2      "Низкая"
+    IDS_SEC_LEVEL3      "Средняя"
+    IDS_SEC_LEVEL4      "Увеличенная"
+    IDS_SEC_LEVEL5      "Высокая"
 END
Index: reactos/dll/cpl/input/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/input/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/input/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+﻿LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
 IDD_PROPPAGESETTINGS DIALOGEX 0, 0, 254, 228
 STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
@@ -17,12 +17,12 @@
 
 IDD_PROPPAGEADVANCEDSETTINGS DIALOGEX 0, 0, 254, 228
 STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
-CAPTION "Advanced Settings"
+CAPTION "Дополнительные параметры"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    GROUPBOX "System Configuration", -1, 7, 7, 240, 70
-    AUTOCHECKBOX "&Turn off advanced text services", IDC_TURNOFFTEXTSVCS_CB, 14, 20, 130, 12
-    LTEXT "Select this check box to turn off advanced text services in all programs.\nThis is not recommended for East Asian users because this closes the language bar.", -1, 14, 40, 230, 35
+    GROUPBOX "Конфигурация Системы", -1, 7, 7, 240, 70
+    AUTOCHECKBOX "&Выключить дополнительные текстовые службы", IDC_TURNOFFTEXTSVCS_CB, 14, 20, 130, 12
+    LTEXT "Установите этот флажок, чтобы выключить дополнительные текстовые службы во всех программах.\nЭто не рекомендуется для Восточно-азиатских пользователей, потому что это закрывает языковую панель.", -1, 14, 40, 230, 35
 END
 
 IDD_KEYSETTINGS DIALOGEX 0, 0, 272, 163
Index: reactos/dll/cpl/intl/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/intl/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/intl/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+﻿LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
 IDD_GENERALPAGE DIALOGEX 0, 0, 246, 230
 STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
@@ -196,16 +196,16 @@
 
 STRINGTABLE
 BEGIN
-    IDS_ERROR "Error"
-    IDS_ERROR_SYMBOL_SEPARATE "The short date components separator contains incorrect symbol(s)"
-    IDS_ERROR_SYMBOL_FORMAT_SHORT "The short date format contains incorrect symbol(s)"
-    IDS_ERROR_SYMBOL_FORMAT_LONG "The long date format contains incorrect symbol(s)"
-    IDS_ERROR_OEM_CODE_PAGE "There was a problem reading the OEM code page"
-    IDS_ERROR_ANSI_CODE_PAGE "There was a problem reading the ANSI code page"
-    IDS_ERROR_INT_KEY_REG "Problem opening key: HKCU\\Control Panel\\International"
-    IDS_ERROR_DEF_INT_KEY_REG "Problem opening key: HKU\\.DEFAULT\\Control Panel\\International"
-    IDS_ERROR_NLS_KEY_REG "Problem opening key: HKLM\\SYSTEM\\CurrentControlSet\\Control\\NLS\\Language"
-    IDS_ERROR_NLS_CODE_REG "Problem opening key: HKLM\\SYSTEM\\CurrentControlSet\\Control\\NLS\\CodePage"
-    IDS_ERROR_INPUT_DLL "Unable to start input.dll"
+    IDS_ERROR "Ошибка"
+    IDS_ERROR_SYMBOL_SEPARATE "Короткий разделитель компонентов даты содержит неверный символ(ы)"
+    IDS_ERROR_SYMBOL_FORMAT_SHORT "Короткий формат даты содержит неверный символ(ы)"
+    IDS_ERROR_SYMBOL_FORMAT_LONG "Длинный формат даты содержит неверный символ(ы)"
+    IDS_ERROR_OEM_CODE_PAGE "Возникла проблема при чтении кодовой страницы OEM"
+    IDS_ERROR_ANSI_CODE_PAGE "Возникла проблема при чтении кодовой страницы ANSI"
+    IDS_ERROR_INT_KEY_REG "Проблема открытия ключа: HKCU\\Control Panel\\International"
+    IDS_ERROR_DEF_INT_KEY_REG "Проблема открытия ключа: HKU\\.DEFAULT\\Control Panel\\International"
+    IDS_ERROR_NLS_KEY_REG "Проблема открытия ключа: HKLM\\SYSTEM\\CurrentControlSet\\Control\\NLS\\Language"
+    IDS_ERROR_NLS_CODE_REG "Проблема открытия ключа: HKLM\\SYSTEM\\CurrentControlSet\\Control\\NLS\\CodePage"
+    IDS_ERROR_INPUT_DLL "Не удается запустить input.dll"
 END
 
Index: reactos/dll/cpl/mmsys/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/mmsys/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/mmsys/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+﻿LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
 IDD_VOLUME DIALOGEX 0, 0, 246, 228
 STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
@@ -170,7 +170,7 @@
     LTEXT "Этот компьютер не может воспроизводить звук пока служба звука ReactOS не включена.", 10245, 60, 25, 150, 40
     AUTOCHECKBOX "&Включить Звук ReactOS", 10253, 60, 68, 150, 9
     LTEXT "Примечания", 10246, 58, 87, 150, 9
-    LTEXT "1. You must be an administrator to enable this service. If you are not logged on as administrator, you will be prompted for an administrator name and password.", 10247, 60, 100, 150, 40
+    LTEXT "1. Вы должны быть администратором, чтобы включить эту службу. Если вы не вошли в систему в качестве администратора, вам будет предложено ввести имя и пароль администратора.", 10247, 60, 100, 150, 40
     LTEXT "2. После того, как вы включите Звук ReactOS, вы должны перезагрузить компьютер.", 10248, 60, 140, 150, 40
 END
 
@@ -223,9 +223,9 @@
 BEGIN
     GROUPBOX "Звук ReactOS", 10259, 7, 5, 213, 192
     ICON 4394, 10257, 25, 25, 20, 20
-    LTEXT "The ReactOS Audio service is now enabled. However, audio may not function properly until you restart ReactOS. If you want to restart now, first save your work and close all programs.", 10261, 60, 25, 150, 50
+    LTEXT "ReactOS сервис Audio включен. Однако, звук может не функционировать должным образом, пока вы не перезагрузите ReactOS. Если вы хотите перезагрузить компьютер сейчас, сначала сохраните данные и закройте все программы.", 10261, 60, 25, 150, 50
     LTEXT "Для перезагрузки ReactOS нажмите ""OK"".", 10262, 60, 75, 150, 20
-    LTEXT "If you Cancel, you will need to restart later for ReactOS Audio to function properly.", 10263, 60, 100, 150, 40
+    LTEXT "Нажмите Отмена, чтобы перезапустить ReactOS позже.", 10263, 60, 100, 150, 40
 END
 
 STRINGTABLE
Index: reactos/dll/cpl/powercfg/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/powercfg/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/powercfg/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-/* Russian translation by Andrey Korotaev (unC0Rr@gmail.com) */
+﻿/* Russian translation by Andrey Korotaev (unC0Rr@gmail.com) */
 
 LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
@@ -140,6 +140,6 @@
     IDS_TIMEOUT14 "через 4 часа"
     IDS_TIMEOUT15 "через 5 часов"
     IDS_TIMEOUT16 "никогда"
-    IDS_DEL_SCHEME "Are you sure you want to delete the power scheme?"
-    IDS_DEL_SCHEME_TITLE "Delete Scheme"
+    IDS_DEL_SCHEME "Вы уверены, что хотите удалить схему питания?"
+    IDS_DEL_SCHEME_TITLE "Удалить Схему"
 END
Index: reactos/dll/cpl/sysdm/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/sysdm/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/sysdm/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+﻿LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
 IDD_PROPPAGEGENERAL DIALOGEX 0, 0, 256, 218
 STYLE DS_SHELLFONT | WS_CHILD | WS_DISABLED | WS_CAPTION
@@ -62,7 +62,7 @@
 
 IDD_SYSSETTINGS DIALOGEX 0, 0, 221, 106
 STYLE DS_SETFONT | DS_MODALFRAME | DS_FIXEDSYS | WS_POPUP | WS_CAPTION
-CAPTION "System Settings"
+CAPTION "Системные параметры"
 FONT 8, "MS Shell Dlg", 0, 0, 0x1
 BEGIN
     GROUPBOX "Version Info", IDC_STATIC, 6, 3, 210, 73
@@ -100,15 +100,15 @@
 
 IDD_COPYPROFILE DIALOGEX 12, 26, 256, 52
 STYLE DS_SHELLFONT | DS_MODALFRAME | DS_CONTEXTHELP | WS_POPUP | WS_VISIBLE | WS_CAPTION | WS_SYSMENU
-CAPTION "Copy Profile"
+CAPTION "Копия Профиля"
 FONT 8, "MS Shell Dlg"
 BEGIN
-    LTEXT "From:", IDC_STATIC, 5, 10, 20, 8
+    LTEXT "из:", IDC_STATIC, 5, 10, 20, 8
     LTEXT "", IDC_COPYPROFILEFROM, 30, 10, 160, 10
-    LTEXT "To:", IDC_STATIC, 5, 30, 20, 8
+    LTEXT "в:", IDC_STATIC, 5, 30, 20, 8
     EDITTEXT IDC_COPYPROFILETO, 30, 30, 160, 12
-    DEFPUSHBUTTON "OK", IDOK, 199, 9, 50, 14
-    PUSHBUTTON "Cancel", IDCANCEL, 199, 30, 50, 14
+    DEFPUSHBUTTON "&ОК", IDOK, 199, 9, 50, 14
+    PUSHBUTTON "Отмена", IDCANCEL, 199, 30, 50, 14
 END
 
 IDD_RENAMEPROFILE DIALOGEX 12, 26, 256, 52
@@ -270,10 +270,10 @@
     IDS_USERPROFILE_TYPE "Тип"
     IDS_USERPROFILE_STATUS "Состояние"
     IDS_USERPROFILE_MODIFIED "Изменен"
-    IDS_MESSAGEBOXTITLE "System control panel applet"
-    IDS_WARNINITIALSIZE "Enter a numeric value for the initial size of the paging file."
-    IDS_WARNMAXIMUMSIZE "Enter a numeric value for the maximum size of the paging file."
-    IDS_WARNINITIALRANGE "The initial size of the paging file must not be smaller than 2 MB and must not exceed the available space on the selected drive."
-    IDS_WARNMAXIMUMRANGE "The maximum size of the paging file must not be smaller than its initial size and must not exceed the available space on the selected drive."
+    IDS_MESSAGEBOXTITLE "Панель управления системы"
+    IDS_WARNINITIALSIZE "Введите числовое значение исходного размера файла подкачки."
+    IDS_WARNMAXIMUMSIZE "Введите числовое значение для параметра максимальный размер файла подкачки."
+    IDS_WARNINITIALRANGE "Начальный размер файла подкачки должен быть не меньше, чем 2 МБ и не должен превышать свободного места на выбранном диске."
+    IDS_WARNMAXIMUMRANGE "Максимальный размер файла подкачки должен быть не меньше, чем начальный размер, который не должен превышать свободного места на выбранном диске."
     IDS_DEVS "\nКоманда ReactOS\n\nКоординатор проекта\n\nАлексей Брагин\n\nКоллектив разработчиков\n\nАлексей Брагин\nЭндрю Гринвуд\nАндрей Коротаев\nАрт Йеркс\nКристоф фон Виттих\nКолин Финк\nДаниэль Раймер\nДмитрий Чапышев\nЭрик Коль\nГед Мёрфи\nГрегор Брюнмар\nЭрве Поссино\nДжеймс Тэбор\nДжеффри Морлан\nЙоханнес Андервальд\nKJK::Гиперион\nМаартен Босма\nМагнус Олсен\nМарк Пиулахс\nМаттиас Купфер\nМайк Норделл\nПитер Вард\nПьер Швейцер\nСавелий Третьяков\nСтефан Гинсберг\nСильвейн Петреоль\nТомас Блюмель\nТимо Кройцер\n\nАлекс Ионеску\nФилип Навара\nГуннар Далснес\nМартин Фукс\nРойс Митчелл III\nБрэндон Тёрнер\nБрайан Палмер\nКаспер Хорнструп\nДэвид Велч\nЭмануэль Алиберти\nГе ван Гельдорп\nГрегор Анич\nДжейсон Филби\nЙенс Коллин\nМихаэль Вирт\nНатан Вудс\nРоберт Дикенсон\nРекс Джоллифф\nVizzini\n\nРелиз-инженеры\n\nКолин Финк\nЦзылян Гуо\n\nРазработка веб-сайта\n\nКолин Финк\nЯн Блумквист Кинандер\nКлеменс Фридл\nЦзылян Гуо\n\nГрафический дизайн\n\nMindflyer\nWierd_W\n\nБлагодарности\n\nвсем участникам проекта\nКоманде Wine\n\n"
 END
Index: reactos/dll/cpl/usrmgr/lang/ru-RU.rc
===================================================================
--- reactos/dll/cpl/usrmgr/lang/ru-RU.rc	(revision 61983)
+++ reactos/dll/cpl/usrmgr/lang/ru-RU.rc	(working copy)
@@ -1,4 +1,4 @@
-LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
+﻿LANGUAGE LANG_RUSSIAN, SUBLANG_DEFAULT
 
 /*
  * Attention Translators:
@@ -14,11 +14,11 @@
 BEGIN
     CONTROL "", IDC_USERS_LIST, "SysListView32", LVS_REPORT | LVS_EDITLABELS | LVS_SINGLESEL |
             LVS_SHOWSELALWAYS | LVS_SORTASCENDING | WS_BORDER | WS_TABSTOP, 7, 7, 238, 85, WS_EX_CLIENTEDGE
-    PUSHBUTTON "A&dd...", IDC_USERS_ADD, 87, 98, 50, 14
-    PUSHBUTTON "&Remove", IDC_USERS_REMOVE, 141, 98, 50, 14
-    PUSHBUTTON "Pr&operties", IDC_USERS_PROPERTIES, 195, 98, 50, 14
-    AUTOCHECKBOX "Require user name and password on system startup.", IDC_USERS_STARTUP_REQUIRE, 10, 118, 200, 14, WS_DISABLED
-    PUSHBUTTON "Reset Password", IDC_USERS_RESET, 165, 200, 80, 14, WS_DISABLED
+    PUSHBUTTON "Добавить...", IDC_USERS_ADD, 87, 98, 50, 14
+    PUSHBUTTON "Удалить", IDC_USERS_REMOVE, 141, 98, 50, 14
+    PUSHBUTTON "Своиства", IDC_USERS_PROPERTIES, 195, 98, 50, 14
+    AUTOCHECKBOX "Требуется имя пользователя и пароль при загрузке системы.", IDC_USERS_STARTUP_REQUIRE, 10, 118, 200, 14, WS_DISABLED
+    PUSHBUTTON "Сбросить пароль", IDC_USERS_RESET, 165, 200, 80, 14, WS_DISABLED
 END
 
 IDD_GROUPS DIALOGEX 0, 0, 252, 223
@@ -28,9 +28,9 @@
 BEGIN
     CONTROL "", IDC_GROUPS_LIST, "SysListView32", LVS_REPORT | LVS_EDITLABELS | LVS_SINGLESEL |
             LVS_SHOWSELALWAYS | LVS_SORTASCENDING | WS_BORDER | WS_TABSTOP, 7, 7, 238, 85, WS_EX_CLIENTEDGE
-    PUSHBUTTON "A&dd...", IDC_GROUPS_ADD, 87, 98, 50, 14
-    PUSHBUTTON "&Remove", IDC_GROUPS_REMOVE, 141, 98, 50, 14
-    PUSHBUTTON "Pr&operties", IDC_GROUPS_PROPERTIES, 195, 98, 50, 14
+    PUSHBUTTON "Добавить...", IDC_GROUPS_ADD, 87, 98, 50, 14
+    PUSHBUTTON "Удалить", IDC_GROUPS_REMOVE, 141, 98, 50, 14
+    PUSHBUTTON "Своиства", IDC_GROUPS_PROPERTIES, 195, 98, 50, 14
 END
 
 IDD_EXTRA DIALOGEX 0, 0, 252, 223
Index: reactos/dll/cpl/wined3dcfg/wined3dcfg.rc
===================================================================
--- reactos/dll/cpl/wined3dcfg/wined3dcfg.rc	(revision 61983)
+++ reactos/dll/cpl/wined3dcfg/wined3dcfg.rc	(working copy)
@@ -36,6 +36,9 @@
 #ifdef LANGUAGE_RO_RO
     #include "lang/ro-RO.rc"
 #endif
+#ifdef LANGUAGE_RU_RU
+    #include "lang/ru-RU.rc"
+#endif
 #ifdef LANGUAGE_TR_TR
     #include "lang/tr-TR.rc"
 #endif